unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Grids, ImgList, ToolWin,Delaunay,Printers,
  Menus,Unit2, Buttons, System.ImageList,System.Types,System.UITypes,
  Vcl.NumberBox;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButtonPan: TToolButton;
    ToolButtonZoom: TToolButton;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButtonMesh0: TToolButton;
    ToolButtonZ: TToolButton;
    ToolButtonPNR: TToolButton;
    ToolButton2: TToolButton;
    ToolButtonDruck: TToolButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButtonMesh1: TToolButton;
    PopupMenu1: TPopupMenu;
    Punkte1: TMenuItem;
    Sichern1: TMenuItem;
    Punktespeichern1: TMenuItem;
    SaveDialog1: TSaveDialog;
    ToolButton9: TToolButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    EditPunktDat: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EditA0: TEdit;
    EditM0: TEdit;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    EditA1: TEdit;
    EditM1: TEdit;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    EditA2: TEdit;
    EditM2: TEdit;
    GroupBox5: TGroupBox;
    TabSheet2: TTabSheet;
    StringGridPkte: TStringGrid;
    TabSheet3: TTabSheet;
    Imagepp: TImage;
    BitBtn1: TBitBtn;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    GroupBox6: TGroupBox;
    EditBem: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ToolButton12: TToolButton;
    GroupBox7: TGroupBox;
    Label7: TLabel;
    EditMasstab: TEdit;
    ToolButtonIsoline: TToolButton;
    Label8: TLabel;
    EditHLIntervall: TEdit;
    TabSheet4: TTabSheet;
    Prot: TMemo;
    NumberBoxH0: TNumberBox;
    procedure FormActivate(Sender: TObject);
    procedure EditPunktDatDblClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ImageppMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageppMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButtonDruckClick(Sender: TObject);
    procedure ToolButtonPNRClick(Sender: TObject);
    procedure ToolButtonZClick(Sender: TObject);
    procedure ToolButtonMesh0Click(Sender: TObject);
    procedure ToolButtonMesh1Click(Sender: TObject);
    procedure Punkte1Click(Sender: TObject);
    procedure Sichern1Click(Sender: TObject);
    procedure Punktespeichern1Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ImageppMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure NumberBoxH0ChangeValue(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    MausposX,MausposY:integer;

    procedure SetMinMaxOffset;
    procedure GetMinMax(var XMin,YMin,ZMin,XMax,YMax,ZMax:Double);
    Procedure ZeigPPunkte;
    Procedure LiesPunkte;
    Function CalcBezugshorizont:Double;
    Function CalcGelaende:Double;
    Procedure fillGrid;
    procedure UpdatePunkte;
    procedure MassenAusgleich;
    Function GetPoint(x,y:Integer):Integer;

  end;
Type
  TPunkt=record
    NR:Integer;
    X,Y,Z:Double;
    Code:ShortInt;
  end;

var
  Form1: TForm1;
  f1:textfile;
  P:Array of Tpunkt;
  XOFFset,YOffset,MF,sumA0,SumA1:Double;
  MinX,MinY,MinZ,MaxX,MaxY,MaxZ,m0,m1,PlotMF:Double;
  Mesh0,Mesh1:TDelaunay;
  MouseSaveX,MouseSaveY:Integer;
  Display:Byte;
  OldFormwidth,OldFormHeight:Integer;
implementation

{$R *.dfm}
{$H+}
function GetVersionInfos(filename:String):string;
var iSize    : Integer;
    data     : Pointer;
    dw       : DWord;
    FileInfo : PVSFixedFileInfo;
begin
  Result      := '?';
  iSize := GetFileVersionInfoSize(PChar(filename),dw);
  if iSize >0 then begin
    GetMem(data,iSize);
    if GetFileVersionInfo(PChar(filename),0,iSize,data) then
      if VerQueryValue(data,'\',Pointer(FileInfo),dw) then
//        result := format('%d.%d.%d.%d',[(FileInfo^.dwFileVersionMS shr 16),(FileInfo^.dwFileVersionMS and $FFFF),(FileInfo^.dwFileVersionLS shr 16),(FileInfo^.dwFileVersionLS and $FFFF)]);
        result := format('%d.%d',[(FileInfo^.dwFileVersionMS shr 16),(FileInfo^.dwFileVersionMS and $FFFF)]);
    FreeMem(data,iSize);
  end;
end;
{$H-}

function GetStr(var s:String):String;
var i:Integer;
begin
  Result:='';
  While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  i:=pos(' ',s);
  if i>0 then
  begin
    Result:=copy(s,1,i-1);
    delete(s,1,i-1);
    While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  end
  else
  begin
    Result:=s;
    s:='';
  end;
end;

function GetFloat(var Satz:String):Double;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  i:=Pos(',',S);
  if i>0 then
  begin
   S[i]:='.';
  end;

  try
   Result:=StrToFloatDef(s,0);
  except
    on EConvertError do
    begin
      Result:=0;
    end;
  end;

end;

function GetInt(var Satz:String):Integer;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  try
   Result:=StrToIntDef(s,0);
  except
    on EConvertError do
    begin
      Result:=0;
    end;
  end;
end;

procedure TForm1.EditPunktDatDblClick(Sender: TObject);
begin
  If opendialog1.execute then
  begin
    EditPunktDat.Text:=opendialog1.Filename;
    LiesPunkte;
    NumberboxH0.Value:=Minz;
    NumberboxH0.MinValue:=MinZ;
    NumberBoxH0.MaxValue:=MaxZ;
    If Length(P)>0 then
    begin
     Toolbutton1.Enabled:=true;
     Speedbutton1.Enabled:=True;
     Speedbutton2.Enabled:=True;
    end;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  formatsettings.DecimalSeparator:='.';
  Formatsettings.ThousandSeparator:=#0;
  FormatSettings.DateSeparator:='.';
  FormatSettings.ShortDateFormat:='dd.mm.yyyy';
  Caption:='Mass Ver. '+GetVersionInfos(Application.ExeName)+' Massenberechnung nach der Prismenmethode';
  Display:=0;MF:=1;
  OldFormwidth:=Form1.width;
  OldFormHeight:=Form1.Height;
  Pagecontrol1.ActivePageIndex:=0;
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  If opendialog1.execute then
  begin
    EditPunktDat.Text:=opendialog1.Filename;
    LiesPunkte;
    NumberboxH0.Value:=Minz;
    If Length(P)>0 then
    begin
     Toolbutton1.Enabled:=true;
     Speedbutton1.Enabled:=True;
     Speedbutton2.Enabled:=True;
    end;
  end;

end;

Function TForm1.CalcBezugshorizont:Double;
var i,i0,i1,i2:Integer;
    A,Ma,H0:Double;
begin
  Mesh0.Free;
  Mesh0:=TDelaunay.Create;
  for i:=1 to High(P) do
  begin
    If P[i].Code=1 then Mesh0.AddPoint(i,P[i].X,P[i].Y,P[i].Z);
  end;
  Mesh0.Mesh;
  result:=0;SumA0:=0;
  Writeln(f1,'Bezugshorizont');
  Writeln(f1,'Masche    Punkt      Punkt      Punkt  Flche m2   Masse m3');
  writeln(f1,'-----------------------------------------------------------');

  Prot.Lines.Add('Bezugshorizont');
  Prot.Lines.Add('Masche    Punkt      Punkt      Punkt  Flche m2   Masse m3');
  Prot.Lines.Add('-----------------------------------------------------------');

  H0:=NumberBoxH0.Value;

  with mesh0 do
  begin
    for i:=1 to howmany do
    begin
     i0:=Vertex^[Triangle^[i].vv0].ID;
     i1:=Vertex^[Triangle^[i].vv1].ID;
     i2:=Vertex^[Triangle^[i].vv2].ID;
     A:=abs(P[i0].X*(P[i1].Y-P[i2].Y)+
            P[i1].X*(P[i2].Y-P[i0].Y)+
            P[i2].X*(P[i0].Y-P[i1].Y))/2;

      SumA0:=SumA0+A;
      ma:=A*((P[i0].Z+P[i1].Z+P[i2].Z)/3-H0);

      Result:=Result+ma;
      writeln(f1,Format('%4d %10d %10d %10d %10.2f %10.2f',[i,P[i0].Nr,P[i1].NR,P[i2].Nr,A,MA]));
      Prot.Lines.add(Format('%4d %10d %10d %10d %10.2f %10.2f',[i,P[i0].Nr,P[i1].NR,P[i2].Nr,A,MA]));
    end;
  end;
  EditA0.Text:=Format('%10.2f',[SumA0]);
  EditM0.Text:=Format('%10.2f',[Result]);
  writeln(f1,'-----------------------------------------------------------');
  Writeln(f1,Format('Summe %42.2f %10.2f',[SumA0,Result]));
  Writeln(f1);

  Prot.Lines.add('-----------------------------------------------------------');
  Prot.Lines.add(Format('Summe %42.2f %10.2f',[SumA0,Result]));
  Prot.Lines.add('');
end;

Function TForm1.CalcGelaende:Double;
var i,i0,i1,i2:Integer;
    A,MA,H0:Double;
begin
  Mesh1.Free;
  Mesh1:=TDelaunay.Create;
  for i:=1 to High(P) do
  begin
    If (P[i].Code=0) or (P[i].code=1) then Mesh1.AddPoint(i,P[i].X,P[i].Y,P[i].Z);
  end;
  Mesh1.Mesh;
  result:=0;SumA1:=0;
  Writeln(F1,'Gelnde');
  Writeln(f1,'Masche    Punkt      Punkt      Punkt  Flche m2   Masse m3');
  writeln(f1,'-----------------------------------------------------------');

  Prot.Lines.add('Gelnde');
  Prot.Lines.add('Masche    Punkt      Punkt      Punkt  Flche m2   Masse m3');
  Prot.Lines.add('-----------------------------------------------------------');

  H0:=NumberboxH0.Value;
  with mesh1 do
  begin
    for i:=1 to howmany do
    begin
     i0:=Vertex^[Triangle^[i].vv0].ID;
     i1:=Vertex^[Triangle^[i].vv1].ID;
     i2:=Vertex^[Triangle^[i].vv2].ID;
     A:=abs(P[i0].X*(P[i1].Y-P[i2].Y)+
            P[i1].X*(P[i2].Y-P[i0].Y)+
            P[i2].X*(P[i0].Y-P[i1].Y))/2;

    SumA1:=SumA1+A;
    ma:=A*((P[i0].Z+P[i1].Z+P[i2].Z)/3-H0);

      Result:=Result+ma;
      writeln(f1,Format('%4d %10d %10d %10d %10.2f %10.2f',[i,P[i0].Nr,P[i1].NR,P[i2].Nr,A,MA]));
      Prot.Lines.Add(Format('%4d %10d %10d %10d %10.2f %10.2f',[i,P[i0].Nr,P[i1].NR,P[i2].Nr,A,MA]));
    end;
  end;
  EditA1.Text:=Format('%10.2f',[SumA1]);
  EditM1.Text:=Format('%10.2f',[Result]);
  writeln(f1,'-----------------------------------------------------------');
  Writeln(f1,Format('Summe %42.2f %10.2f',[SumA1,Result]));

  Prot.Lines.add('-----------------------------------------------------------');
  Prot.Lines.add(Format('Summe %42.2f %10.2f',[SumA1,Result]));

end;

procedure Tform1.GetMinMax(var XMin,YMin,ZMin,XMax,YMax,ZMax:Double);
var
    i:integer;
begin
  XMin:=1E12;YMin:=1E12;ZMIN:=1E12;
  XMax:=-1E12;YMax:=-1E12;ZMax:=-1E12;
  for i:=1 to high(P) do
  begin
    if P[i].X>XMax then XMax:=P[i].X;
    if P[i].Y>YMax then YMax:=P[i].Y;
    if P[i].Z>ZMax then ZMax:=P[i].Z;
    if P[i].X<XMin then XMin:=P[i].X;
    if P[i].Y<YMin then YMin:=P[i].Y;
    if P[i].Z<ZMin then ZMin:=P[i].Z;

  end;
 end;
procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var X,Y:Integer;
begin
  Screen.Cursor:=crHourGlass;
  x:=mausPosX;
  y:=mausPosY;

  Yoffset:=YOffset+X*MF;
  XOffset:=XOffset-Y*MF;
  MF:=MF*1.25;
  Yoffset:=YOffset-X*MF;
  XOffset:=XOffset+Y*MF;
  ZeigPPunkte;
  Screen.Cursor:=crDefault;
  Handled:=True;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var X,Y:Integer;
begin
  Screen.Cursor:=crHourGlass;
  x:=MausPosX;
  y:=MausPosY;
  Yoffset:=YOffset+X*MF;
  XOffset:=XOffset-Y*MF;
  MF:=MF/1.25;
  Yoffset:=YOffset-X*MF;
  XOffset:=XOffset+Y*MF;
  ZeigPPunkte;
  Screen.Cursor:=crDefault;
  Handled:=True;
end;

Function Tform1.GetPoint(x,y:Integer):Integer;
var i:Integer;
    d,dist,xx,yy:Double;
begin
  YY:=Y*MF+XOffset;
  XX:=X*MF+YOffset;

  xx:=XOffset-y*MF;
  yy:=x*MF+Yoffset;

  d:=1E10;
  Result:=-1;
  for i:=low(p) to high(p) do
  begin
    dist:=sqrt(sqr(P[i].X-xx)+sqr(P[i].Y-yy));
    if dist<d then
    begin
      d:=dist;result:=i;
    end;
  end;
end;

procedure TForm1.ImageppMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i:Integer;
begin
  If ToolButtonZoom.Down then
  begin
    If Button=mbLeft then
    begin
      Yoffset:=YOffset+X*MF;
      XOffset:=XOffset-Y*MF;
      MF:=MF/1.25;
      Yoffset:=YOffset-X*MF;
      XOffset:=XOffset+Y*MF;
      ZeigPPunkte;
    end;
    If Button=mbRight then
    begin
      Yoffset:=YOffset+X*MF;
      XOffset:=XOffset-Y*MF;
      MF:=MF*1.25;
      Yoffset:=YOffset-X*MF;
      XOffset:=XOffset+Y*MF;
      ZeigPPunkte;
    end;
  end;
  If ToolButtonPan.Down then
  begin
    MouseSaveX:=X;
    MouseSaveY:=Y;
  end;
  i:=getpoint(x,y);
  if i>0 then
  begin
    statusbar1.SimplePanel:=True;
    Statusbar1.SimpleText:=format('%10d %10.3f %10.3f %8.3f %3d',[P[i].NR,P[i].Y,P[i].X,P[i].Z,P[i].Code]);
  end;
end;

procedure TForm1.ImageppMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    mausposX:=X;mausPosy:=y;
end;

procedure TForm1.ImageppMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If ToolbuttonPan.down then
  begin
    Xoffset:=XOffset-(MouseSaveY-Y)*MF;
    Yoffset:=YOffset+(MouseSaveX-X)*MF;
    ZeigPPunkte;
  end;
end;

procedure TForm1.ZeigPPunkte;
var
    i,j,YDir:Integer;
    XMax,YMax,YB,XB:Longint;
    AktCanvas:Tcanvas;
    AktColor:Tcolor;
    OldMF:Double;
    Clip:Trect;
begin
  //  Bitmap.canvas.FillRect(Bitmap.BoundsRect);
    If Display=0 then
    begin
      XMax:=Tabsheet2.Width;
      YMax:=Tabsheet2.Height;
      ImagePP.Picture.Bitmap.Height:=YMax;
      ImagePP.Picture.Bitmap.Width:=XMax;
      AktCanvas:=ImagePP.Canvas;
      AktCanvas.Font.Size:=8;
      OldMF:=MF;
      YDir:=-1;
    end
  else
    begin
      Printer.BeginDoc;
      SetMapMode(Printer.Canvas.Handle,MM_LOMETRIC);
      XMax:= GetDeviceCaps(Printer.Canvas.Handle, 4); (*LOGPIXELSX*)
      YMax:= GetDeviceCaps(Printer.Canvas.Handle, 6); (*LOGPIXELSY*)
      AktCanvas:=Printer.Canvas;
      AktCanvas.Font.Size:=4;
      OldMF:=MF;
      MF:=MF/5;
      YDir:=1;
    end;

  AktColor:=AktCanvas.Pen.Color;
  AktCanvas.Brush.Style:=BsSolid;
  AktCanvas.Brush.Color:=clWhite;
  AktCanvas.FillRect(Rect(0,0,XMax,YMax));
  AktCanvas.Pen.Mode:=pmCopy;
  AktCanvas.Pen.Width:=1;
  AktCanvas.Pen.Style:=PsSolid;
  SetBKColor(AktCanvas.Brush.Handle,clWhite);
//  PrinterPreview;
  AktCanvas.Brush.Style:=bsClear;
  //AktSetBKMode(AktCanvas.Handle,1);
  AktCanvas.Font.Name:='Arial';
  AktCanvas.Font.Color:=ClBlack;

  For i:=1 to High(P) do
  begin
    YB:=YDir*Round((P[i].X-XOffset)/MF);
    XB:= Round((P[i].Y-YOffset)/MF);
    If ToolButtonPnr.Down then
    begin
      AktCanvas.Brush.Style:=bsClear;
      AktCanvas.Font.Color:=clBlack;
      AktCanvas.TextOut(XB+10,YB+YDir*10,IntTostr(P[i].NR));
    end;
    If ToolButtonZ.Down then
    begin
      AktCanvas.Brush.Style:=bsClear;
      AktCanvas.Font.Color:=clBlack;
      AktCanvas.TextOut(XB+10,YB+YDir*10,Format('%7.3f',[P[i].Z]));
    end;
    AktCanvas.Pen.Color:=clBlack;
    AktCanvas.Ellipse(XB-1,YB-YDIR*1,XB+1,YB+YDIR*1);
  end;

  If ToolbuttonMesh0.down then
    with mesh0 do
    begin
      if (HowMany > 0) then
      begin
        If ToolButtonMesh0.down then
        begin
          AktCanvas.pen.color:=clblue;
          For i:= 1 To HowMany do
            AktCanvas.Polygon([Point(Trunc((Vertex^[Triangle^[i].vv0].Y-Yoffset)/MF), YDIR*Trunc((Vertex^[Triangle^[i].vv0].X-XOffset)/MF)),
                                  Point(Trunc((Vertex^[Triangle^[i].vv1].Y-YOffset)/MF), YDIR*Trunc((Vertex^[Triangle^[i].vv1].X-XOffset)/MF)),
                                  Point(Trunc((Vertex^[Triangle^[i].vv2].Y-Yoffset)/MF), YDir*Trunc((Vertex^[Triangle^[i].vv2].X-XOffset)/MF))]);
        end;
      end;
    end;

  If ToolbuttonMesh1.down then
  begin
    with mesh1 do
    begin
      if (HowMany > 0) then
      begin
        If ToolButtonMesh1.down then
        begin
          AktCanvas.pen.color:=clRed;
          For i:= 1 To HowMany do
            AktCanvas.Polygon([Point(Trunc((Vertex^[Triangle^[i].vv0].Y-Yoffset)/MF), YDIR*Trunc((Vertex^[Triangle^[i].vv0].X-XOffset)/MF)),
                               Point(Trunc((Vertex^[Triangle^[i].vv1].Y-YOffset)/MF), YDIR*Trunc((Vertex^[Triangle^[i].vv1].X-XOffset)/MF)),
                               Point(Trunc((Vertex^[Triangle^[i].vv2].Y-Yoffset)/MF), YDir*Trunc((Vertex^[Triangle^[i].vv2].X-XOffset)/MF))]);
        end;
      end;
    end;
  end;

  if ToolbuttonIsoline.down then
  begin
    if ToolbuttonMesh0.Down then
    begin
       Mesh0.InitialiseContourLevels(Mesh0.zMin,Mesh0.zMax,StrtoFloatDef(EditHlIntervall.text,1));
       Mesh0.InitialiseContourLevels(Mesh0.zMin,Mesh0.zMax,StrtoFloatDef(EditHlIntervall.text,1));
       Mesh0.CalculateContours;
       mesh0.SortContourLines;

       AktCanvas.Pen.Color:=clBlue;
       with mesh0 do
      begin
        for i:=0 to Contour.NoLevels-1 do
        begin
          for j:=0 to High(Contour.Contours[i]) do
          begin
            AktCanvas.MoveTo(Trunc((ConTour.Points[Contour.Contours[i][j].sp].Y-Yoffset)/MF),Trunc((ConTour.Points[Contour.Contours[i][j].sp].X-XOffset)*YDIR/MF));
            AktCanvas.LineTo(Trunc((ConTour.Points[Contour.Contours[i][j].ep].Y-YOffset)/MF),Trunc((ConTour.Points[Contour.Contours[i][j].ep].X-Xoffset)*YDIR/MF));
          end;
        end;
      end;
    end;

    if ToolbuttonMesh1.Down then
    begin
       Mesh1.InitialiseContourLevels(Mesh1.zMin,Mesh1.zMax,StrtoFloatDef(EditHlIntervall.text,1));
       Mesh1.InitialiseContourLevels(Mesh1.zMin,Mesh1.zMax,StrtoFloatDef(EditHlIntervall.text,1));
       Mesh1.CalculateContours;
       mesh1.SortContourLines;

       AktCanvas.Pen.Color:=clMaroon;
       with mesh1 do
       begin
         for i:=0 to Contour.NoLevels-1 do
         begin
           for j:=0 to High(Contour.Contours[i]) do
           begin
             AktCanvas.MoveTo(Trunc((ConTour.Points[Contour.Contours[i][j].sp].Y-Yoffset)/MF),Trunc((ConTour.Points[Contour.Contours[i][j].sp].X-XOffset)*YDIR/MF));
             AktCanvas.LineTo(Trunc((ConTour.Points[Contour.Contours[i][j].ep].Y-YOffset)/MF),Trunc((ConTour.Points[Contour.Contours[i][j].ep].X-Xoffset)*YDIR/MF));
           end;
         end;
       end;
    end;

  end;

  If Toolbutton12.Down and (Display=0) then
  begin
    PlotMF:=StrToFloat(Trim(EditMasstab.text))/1000;
    XMax:= GetDeviceCaps(Printer.Handle, 88); (*LOGPIXELSX*)
    Ymax:= GetDeviceCaps(Printer.Handle, 90); (*LOGPIXELSY*)
    Clip.TOp:=0;
    Clip.Left:=0;
    Clip.Bottom:=Printer.PageHeight;
    Clip.Right:=Printer.PageWidth;
    Clip.Right:=Round(Clip.Right*25.4/XMax/MF*PlotMF);
    Clip.Bottom:=Round(Clip.Bottom*25.4/YMAX/MF*PlotMF);
    AktCanvas.Pen.Style:=psDash;
    AktCanvas.Pen.Color:=clRed;
    AktCanvas.Brush.style:=bsClear;
    AktCanvas.Rectangle(Clip.TOP,CLIP.Left,CLIP.Right,CLIP.Bottom);
    Imagepp.Refresh;
    AktCanvas.Pen.Style:=psSolid;
    XMax:=Tabsheet2.Width;
    YMax:=Tabsheet2.Height;
  end;

  If Display=1 then
  begin
    Printer.EndDoc;
    MF:=OldMF;
    Display:=0;
  end;
  AktCanvas.Pen.Color:=AktColor;
end;



procedure TForm1.SetMinMaxOffset;
begin
  GetMinMax(MinX,MinY,MinZ,MaxX,MaxY,MaxZ);
  MF:=(MaxX-MinX)/(Imagepp.Height-20);
  YOffset:=MinY-10*MF;XOffset:=MaxX+10*MF;
end;

procedure TForm1.Sichern1Click(Sender: TObject);
var i,j:Integer;
begin
  j:=stringGridpkte.Row;
  StringGridpkte.RowCount:=StringGridpkte.RowCount+1;
  for i:=StringGridpkte.RowCount-1 downto j do
    StringGridPkte.Rows[i+1]:=StringGridPkte.Rows[i];
  StringGridPkte.Rows[j].Clear;
end;

procedure Tform1.Massenausgleich;
var H0,A,SumA0,ma,diff:Double;
    i,i0,i1,i2:Integer;
begin
  diff:=m1-m0;
  if Length(P)>0 then
  begin
    H0:=(MinZ+MaxZ)/2;
    repeat
    SumA0:=0;ma:=0;
    with mesh1 do
    begin
      for i:=1 to howmany do
      begin
        i0:=Vertex^[Triangle^[i].vv0].ID;
        i1:=Vertex^[Triangle^[i].vv1].ID;
        i2:=Vertex^[Triangle^[i].vv2].ID;
        A:=abs(P[i0].X*(P[i1].Y-P[i2].Y)+
            P[i1].X*(P[i2].Y-P[i0].Y)+
            P[i2].X*(P[i0].Y-P[i1].Y))/2;

        SumA0:=SumA0+A;
        ma:=ma+A*((P[i0].Z+P[i1].Z+P[i2].Z)/3-H0);
      end;
    end;
    H0:=H0+(ma-diff)/SumA0;
    until abs(ma-diff)<0.001;
  end;
  NumberboxH0.Value:=H0;
end;

procedure TForm1.NumberBoxH0ChangeValue(Sender: TObject);
begin

  toolbutton1.Click;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var H0:Double;
begin
  //Massenausgleich;

  if Length(P)>0 then
  begin
    H0:=(MinZ+MaxZ)/2;
    repeat
      NumberboxH0.value:=H0;
      Toolbutton1.Click;
      H0:=NumberBoxH0.Value+M0/SumA0;
      NumberboxH0.Value:=H0;
    until abs(m0)<0.001;
  end;

end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var H0:Double;
begin
  if Length(P)>0 then
  begin
    H0:=(MinZ+MaxZ)/2;
    repeat
      NumberboxH0.Value:=H0;
      Toolbutton1.Click;
      H0:=NumberboxH0.Value+M1/SumA1;
    until abs(m1)<0.001;
  end;

end;

procedure TForm1.UpdatePunkte;
var i:integer;
begin
  setlength(P,1);
  For i:=1 to StringGridPkte.Rowcount-1 do
  begin
    setlength(P,Length(P)+1);
    P[i].NR:=StrToInt(Trim(StringGridPkte.Cells[1,i]));
    P[i].Y:=StrToFloat(Trim(StringGridPkte.Cells[2,i]));
    P[i].X:=StrToFloat(Trim(StringGridPkte.Cells[3,i]));
    P[i].Z:=StrToFloat(Trim(StringGridPkte.Cells[4,i]));
    P[i].Code:=StrToInt(Trim(StringGridPkte.Cells[5,i]));
  end;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  ToolButtonZoom.Enabled:=False;
  ToolButtonPan.Enabled:=False;
  ToolButtonPnr.Enabled:=False;
  ToolButtonZ.Enabled:=False;
  ToolButtonMesh0.Enabled:=False;
  ToolButtonMesh1.Enabled:=False;
  ToolbuttonDruck.Enabled:=False;

  case PageControl1.TabIndex of
  0:begin
      Form1.Width:=OldFormWidth;
      Form1.Height:=OldFormHeight;
      Form1.Position:=poScreencenter;
    end;
  1:begin
      Form1.Width:=OldFormWidth;
      Form1.Height:=OldFormHeight;
      Form1.Position:=poscreencenter;
      FillGrid;
    end;
  2:begin
      Form1.Width:=screen.Width-100;
      Form1.Height:=Screen.Height-100;
      Form1.Position:=poscreencenter;
      Display:=0;
      ZeigPPunkte;
      ToolButtonZoom.Enabled:=True;
      ToolButtonPan.Enabled:=True;
      ToolButtonPnr.Enabled:=True;
      ToolButtonZ.Enabled:=True;
      ToolButtonMesh0.Enabled:=True;
      ToolButtonMesh1.Enabled:=True;
      ToolbuttonDruck.Enabled:=True;
    end;
  end;

end;

procedure TForm1.Punkte1Click(Sender: TObject);
var i,j:Integer;
begin
  j:=StringGridPkte.Row;
  for i:=j to StringGridPkte.RowCount-1 do
    StringGridPkte.rows[i]:=StrinGgridPkte.rows[i+1];
  StringGridPkte.RowCount:=StringGridPkte.RowCount-1
end;

procedure TForm1.Punktespeichern1Click(Sender: TObject);
var i:Integer;
    f:textfile;
begin
  Savedialog1.FileName:=EditPunktDat.Text;
  if savedialog1.Execute then
  begin
    UpdatePunkte;
    assignfile(f,Savedialog1.Filename);
    rewrite(f);
    for i:=1 to high(P) do
      writeln(f,format('%16d %5d %12.3f %12.3f %10.3f',[P[i].NR,P[i].Code,P[i].Y,P[i].X,P[i].Z]));
    closefile(f);
    EditPunktDat.Text:=savedialog1.FileName;
  end;
end;

Procedure TForm1.LiesPunkte;
var f:Textfile;
    satz:String;
begin
  If Fileexists(EditPunktDat.Text) then
  begin
    assignfile(f,EditPunktDat.text);
    {$I-}
    reset(f);
    If IOresult>0 then exit;
    {$I+}
    Setlength(P,1);
    while not eof(f) do
    begin
      Readln(f,Satz);
      setlength(P,length(P)+1);
      P[high(P)].Nr:=getint(Satz);
      P[high(P)].Code:=getint(Satz);
      P[high(P)].Y:=getFloat(Satz);
      P[high(P)].X:=getFloat(Satz);
      P[high(P)].Z:=getFloat(Satz);
    end;
    closefile(f);
    SetMinmaxOffset;
  end;
end;

procedure Tform1.FillGrid;
var i,j,tmp,max:integer;
begin
  with StringgridPkte do
  begin
    Cells[0,0]:='ID';
    Cells[1,0]:='NR';
    cells[2,0]:='Y';
    cells[3,0]:='X';
    cells[4,0]:='Z';
    cells[5,0]:='Code';
    RowCount:=length(P);
    for i:=1 to high(p) do
    begin
      cells[0,i]:=Format('%d',[i]);
      cells[1,i]:=Format('%d',[P[i].NR]);
      cells[2,i]:=format('%10.3f',[P[i].Y]);
      cells[3,i]:=format('%10.3f',[P[i].X]);
      cells[4,i]:=format('%10.3f',[P[i].Z]);
      cells[5,i]:=format('%d',[P[i].Code]);
    end;
    // Spaltenbreite einstellen
    for j := 0 to colCount-1 do
    begin
       max:=0;
       for i:=0 to rowcount-1 do
       begin
         tmp:=canvas.TextWidth(Cells[j,i]);
         if tmp>max then max:=tmp;
       end;
       If Max>DefaultColwidth then colwidths[j]:=max+5;
    end;

  end;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  Assignfile(f1,copy(EditPunktDat.Text,1,length(EditPunktDat.Text)-3)+'LST');
  rewrite(f1);
  prot.Lines.Clear;
  Writeln(f1,'Massenberechnung Mass Ver. '+GetVersionInfos(Application.ExeName));
  Writeln(f1,EditBem.text);

  Prot.Lines.add('Massenberechnung Mass Ver. '+GetVersionInfos(Application.ExeName));
  Prot.Lines.add(EditBem.text);

  LiesPunkte;
  writeln(f1,'Hhenbezug'+NumberboxH0.text+' m');
  Prot.Lines.add('Hhenbezug'+NumberboxH0.Text+' m');
  m0:=CalcBezugshorizont;
  m1:=CalcGelaende;
  writeln(f1);
  Prot.Lines.Add('');
  writeln(f1,Format('Differenz Gelnde - Bezugshorizont:   %10.2f %10.2f',[suma1-suma0,m1-m0]));
  Prot.Lines.add(Format('Differenz Gelnde - Bezugshorizont:   %10.2f %10.2f',[suma1-suma0,m1-m0]));

  Closefile(f1);
  EditM2.text:=format('%10.2f',[M1-m0]);
  EditA2.Text:=format('%10.2f',[StrTofloat(EditA1.Text)-StrToFloat(EditA0.Text)]);
end;



procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  PrintersetupDialog1.Execute;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  Form2.show;
end;

procedure TForm1.ToolButtonDruckClick(Sender: TObject);
begin
  Display:=1;
  ZeigPPunkte;
  Display:=0;
end;

procedure TForm1.ToolButtonMesh0Click(Sender: TObject);
begin
  ZeigPPunkte;
end;

procedure TForm1.ToolButtonMesh1Click(Sender: TObject);
begin
  ZeigPPunkte;
end;

procedure TForm1.ToolButtonPNRClick(Sender: TObject);
begin
  ZeigPPunkte;
end;

procedure TForm1.ToolButtonZClick(Sender: TObject);
begin
 ZeigPPunkte;
end;

procedure TForm1.ToolButton5Click(Sender: TObject);
begin
  Setlength(P,0);
  Mesh0.Free;
  Mesh1.Free;
  Close;
end;

procedure TForm1.ToolButton9Click(Sender: TObject);
begin
  Punktespeichern1Click(Sender);
end;

end.
